#include <iostream>
#include <vector>

using namespace std;

const long long INF = 1000000000000000000LL;

struct FvTree {
    int sz;
    vector<int> fv;

    FvTree(int sz) : sz(sz) {
        fv.resize(sz);
    }

    void add(int i, int v) {
        while (i < sz) {
            fv[i] += v;
            i = i | (i + 1);
        }
    }

    int pref(int i) {
        int s = 0;
        while (i >= 0) {
            s += fv[i];
            i = (i & (i + 1)) - 1;
        }
        return s;
    }

    int get(int l, int r) {
        return pref(r) - pref(l - 1);
    }
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        --a[i];
    }
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        b[a[i]] = i;
    }

    vector<long long> cntl(n), cntr(n);
    FvTree stl(n);
    for (int i = 0; i < n; i++) {
        cntl[i] = stl.get(b[i] + 1, n - 1);
        stl.add(b[i], 1);
        if (i > 0) {
            cntl[i] += cntl[i - 1];
        }
    }
    FvTree str(n);
    for (int i = n - 1; i >= 0; i--) {
        cntr[i] = str.pref(b[i]);
        str.add(b[i], 1);
        if (i < n - 1) {
            cntr[i] += cntr[i + 1];
        }
    }

    long long best = INF;
    for (int i = 0; i < n; i++) {
        best = min(best, (i > 0 ? cntl[i - 1] : 0) + (i < n - 1 ? cntr[i + 1] : 0));
    }

    cout << best << endl;

    return 0;
}
